// Full program; does IO through stdio and stdout. Compiles itself using gcc, which must be available.

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#define _empty()
#define _defer(...) __VA_ARGS__ _empty()
#define obstruct(...) __VA_ARGS__ _defer(_empty)()

#define eval(...) _eval(_eval(_eval(__VA_ARGS__)))
#define _eval(...) __eval(__eval(__eval(__VA_ARGS__)))
#define __eval(...) ___eval(___eval(___eval(__VA_ARGS__)))
#define ___eval(...) ____eval(____eval(____eval(__VA_ARGS__)))
#define ____eval(...) _____eval(_____eval(_____eval(__VA_ARGS__)))
#define _____eval(...) ______eval(______eval(______eval(__VA_ARGS__)))
#define ______eval(...) __VA_ARGS__

#define concat(x, y) x##y

#define _ifelse_const_0(t, e) e
#define _ifelse_const_1(t, e) t
#define ifelse(c) concat(_ifelse_const_, c)

#define _return_second(a, b, ...) b
#define is_empty(...) _return_second(~, ##__VA_ARGS__, 1)

#define comma ,

#define tail(x, ...) __VA_ARGS__

#define _fib(a, b, ...) ifelse(is_empty(__VA_ARGS__))(, comma a+b obstruct(_fib_id)()(b, (a+b), tail(__VA_ARGS__)))
#define _fib_id() _fib
// A macro that replaces a series of 0s with the Fibonacci sequence. Hardcodes the first few numbers for performance to make the program easier to test, as this chews through memory.
#define fib(_, __, ___, ____, _____, ______, _______, ________, ...) 0, 1, 1, 2, 3, 5, 8, 13 eval(_fib(8, 13, ##__VA_ARGS__))

size_t fibs[] = {fib(
    0, 0, 0, 0, 0, 0, 0, 0
)};

static inline __attribute__((always_inline)) size_t nth_fib(size_t i) {
    if (i < sizeof (fibs) / sizeof (fibs[0])) {
        return fibs[i];
    }

    // we weren't compiled with enough fibonacci numbers, so recompile with 8 more
    FILE *src = fopen(__FILE__, "r");
    FILE *dst = fopen("cpp_new.c", "w");
    char buf[128];
    for (size_t line = 1; ; line++) {
        if (!fgets(buf, sizeof (buf), src)) break;
        if (line == 39) {  // I have no idea why this has to be 39 even though the actual line is line 38
            fputs(buf, dst);
            fputc(',', dst);
            fputs(buf, dst);
        } else {
            fputs(buf, dst);
        }
    }
    fclose(src);
    fclose(dst);

    rename("cpp_new.c", __FILE__);
    system("gcc " __FILE__ " -O2 -o cpp");
    // and now we do it all over again
    execl("cpp", "cpp", NULL);
}

int main() {
    char _target_str_buf[32];
    char *target_str = getenv("CODE_GUESSING_N");
    if (target_str == NULL) {
        fgets(_target_str_buf, sizeof (_target_str_buf), stdin);
        setenv("CODE_GUESSING_N", _target_str_buf, 0);
        target_str = _target_str_buf;
    }

    size_t target;
    sscanf(target_str, "%zu", &target);

    while (target) {
        size_t last_fib;
        for (size_t i = 2; ; i++) {
            size_t this_fib = nth_fib(i);
            if (target < this_fib) {
                printf("%zu ", i-1);
                target -= last_fib;
                break;
            }
            last_fib = this_fib;
        }
    }
}
